unit PanelPicture;
{ Componente  : PanelPicture

  Utilizzo    : Un panel con possibilita di essere spostato run time.

  E-Mail      : delphiruby@yahoo.it

  Web site    : http://www.compuservonline/delphiruby.com/

  Version     : 1.1

  Note        : Componente con le caratteristiche di un panel ma senza
                il BevelInner, BevelOuter, BevelWidth abilitato e con
                l'effetto di angoli evidenziati.


  Uso         : Movimento Pannello : Si pu scegliere quale tipo di blocco
                                     attuare andando a selezionare i valori
                                     boleani nell'object inspector:
                Bloccato       : Non  possibile spostare il componente.
                Auto           : Tramite il mouse  possibile spoatre il
                                 componente sul video.
                Form           : Posizionandosi sul componente tramite il mouse
                                 spostiamo l'intero Form.

                Colore angoli  : Possiamo scegliere il colore degli angoli in
                                 rilievo,
                Angoli visibili: Sceliamo se vedere gli angoli in rilievo
                                 oppure no.

                Muove On Line   : Con il movimento pannello in auto e Form
                                  ci permette di scegliere se la rigenerazione
                                  video del componente  continua o se viene
                                  fatta a fine spostamento.
Copyright  2002 DelphiRuby }
               
interface

uses
SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
Forms, Dialogs, ExtCtrls;

type
  MuoviPannello = (Bloccato, Auto, Form);
  TPanelPicture = class(TPanel)
private
    FAutore, Vuoto : String;
    OldX, OldY, OldLeft, OldTop : Integer;
    ScreenDC : HDC;
    MoveRect : TRect;
    Moving : Boolean;
    fSposta : MuoviPannello;
    fColoreAngoli : TColor;
    fTempColor :TFont;
    fAngoliVisibili : Boolean;
    fMuoveOnLine : Boolean;
    FBorder:TBorderStyle;
    procedure SetfColoreAngoli(const Value: TColor);
    procedure SetAngoliVisibili(const Value: Boolean);
    procedure SetBorder(const Value: TBorderStyle);

protected
    procedure Paint; override;

public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure MouseDown(Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer); override;

published
 property Autore: string  read FAutore write Vuoto ;
 property MovimentoTipo : MuoviPannello  read fSposta write fSposta default bloccato;
 property ColoreAngoli: TColor read fColoreAngoli write SetfColoreAngoli default clRed;
 property AngoliVisibili: boolean read fAngoliVisibili write SetAngoliVisibili  default True ;
 property MuoveOnLine: boolean read fMuoveOnLine write fMuoveOnLine  default True ;
 property BorderStyle : TBorderStyle read FBorder write SetBorder;
    end;

procedure Register;

implementation

constructor TPanelPicture.Create(AOwner: TComponent);
Begin
Inherited Create(Aowner);
  FAutore  :='DelphiRuby (Copyright  2002)';
  BorderWidth := 8;
  Color := clGreen;
  fColoreAngoli := clRed;
  FAngoliVisibili := True;
  fMuoveonLine := True;
  fTempColor := Font;
end;

destructor TPanelPicture.Destroy;
 begin
  inherited;

 end;

procedure TPanelPicture.Paint;
Var
 A : Integer;
Begin
 fTempColor := Font;
 A := GetTextLen;
 With Canvas Do
  Begin
   Brush.Color := Color;
   Rectangle(0,0,Width,Height);

{**************************************************}
	{Linea grigia e nera interna verticale sinistra corpo pannello}

   	Pen.Color := clSilver;     // Linea grigia sinistra che crea l'effetto
	Moveto(0+1,0);
	Lineto(0+1,Height);

     	Pen.Color := clBlack;     // Linea nera interana sinistra
     	Moveto(0+4,4);
     	Lineto(0+4,Height-3);

	{Linea grigia interna verticale destra corpo pannello}
       	Pen.Color := clSilver;
	Moveto(Width-4,4);
	Lineto(Width-4,Height-3);

	{Linnee nere e grigie superiori del corpo pannello}
       	Pen.Color := clBlack;
	Moveto(0,0);
	Lineto(Width,0);

     	Pen.Color := clSilver;  // Linea grigia superiore che crea l'effetto
      	Moveto(1,0+1);
      	Lineto(Width-1,0+1);

    	Pen.Color := clBlack;
	Moveto(5,0+4);
	Lineto(Width-3,0+4);

	{Linnee nere e grigie inferiori del corpo pannello}
     	Pen.Color := clSilver;
	Moveto(5,Height-4);
	Lineto(Width-4,Height-4);

	Pen.Color := clBlack;
	Moveto(0,Height-1);
     	Lineto(Width,Height-1);

     Font := fTempColor;
     TextOut ((Width div 2)-((A* font.Size) div 3) ,(Height div 2) -(font.Size div 2)-3 , caption) ;


 //---------------    INIZIO DISEGNO ANGOLI EVIDENZIATI -----------------------

   if not FAngoliVisibili then exit;

    	Pen.Color := clWhite;

       	MoveTo(0+1,0+1);
	LineTo(0+1,15);
	Moveto(0+1,0+1);
	LineTo(15,0+1);

	MoveTo(0+1,Height-1);
	LineTo(0+1,Height-16);

        Pen.Color := clBlack;
	MoveTo(Width-2,Height-1);
	LineTo(Width-15,Height-1);
	MoveTo(Width-1,Height-1);
	LineTo(Width-1,Height-15);
	Pen.Color := clWhite;
	MoveTo(Width-15,Height-1);
	LineTo(Width-16,Height-1);
	MoveTo(Width-1,Height-15);
	LineTo(Width-1,Height-16);

	MoveTo(Width-15, 1);
        LineTo(Width-1, 1);

    	Pen.Color := clBlack;
    	Brush.Color := clBlack;

	MoveTo(0+5,0+5);
	LineTo(0+5,6+6);
	Moveto(0+5,0+5);
	LineTo(6+6,0+5);

	MoveTo(0+5,Height-5);
	LineTo(0+5,(Height-5)-7);
	Moveto(0+5,Height-5);
	LineTo(12,Height-5);

	Pen.Color := clWhite;
	MoveTo(0+6,Height-5);
	LineTo(11,Height-5);
	Pen.Color := clBlack;

	Pen.Color := clWhite;
	MoveTo(Width-5,Height-5);
	LineTo(Width-5,Height-12);
	MoveTo(Width-5,Height-5);
	LineTo(Width-12,Height-5);

        Pen.Color := clBlack;
	MoveTo(Width-11,5);
	LineTo(Width-5,5);
	Pen.Color := clWhite;
	MoveTo(Width-5,5);
        LineTo(Width-5,13);

	Pen.Color := clBlack;

	MoveTo(0+1,15);
	LineTo(0+4,12);

	Moveto(2,Height-13);
	LineTo(3,Height-12);
	Moveto(4,Height-11);
	LineTo(4,Height-11);


	MoveTo(15,0+1);
	LineTo(12,0+4);

	Pen.Color := clWhite;
	Moveto(2,Height-14);
	LineTo(5,Height-11);

	Pen.Color := clBlack;
	MoveTo(11,Height-5);
	LineTo(15,Height-1);

	Pen.Color := clWhite;
	MoveTo(Width-15,Height-1);
	LineTo(Width-10,Height-6);
	MoveTo(Width-1,Height-15);
	LineTo(Width-6,Height-10);

        Pen.Color := clBlack;
	MoveTo(Width-1,16);
	LineTo(Width-5,12);

	MoveTo(Width-14,2);
	LineTo(Width-12,4);


	Brush.Color := FColoreAngoli;
	Pen.Color := FColoreAngoli;

    	Rectangle(2,2,5,12);
    	Rectangle(2,2,12,5);

	Moveto(12,2);
	LineTo(14,2);
	Moveto(12,3);
	LineTo(13,3);

	MoveTo(2,12);
	LineTo(2,14);
	MoveTo(3,12);
	LineTo(3,13);

	{2 rettangoli in basso a sinistra}
     	Rectangle(2,Height-1,12,Height-4);
     	Rectangle(2,Height-2,5,Height-11);

    	Moveto(2,Height-13);
	LineTo(3,Height-12);
	Moveto(2,Height-12);
	LineTo(4,Height-12);
	Moveto(4,Height-11);
	LineTo(4,Height-11);

	MoveTo(12,Height-3);
	LineTo(13,Height-2);
	MoveTo(14,Height-1);
	LineTo(14,Height-1);
	MoveTo(12,Height-2);
	LineTo(14,Height-2);

  {-----------------------}
	{2 rettangoli in basso a destra}
     	Rectangle(Width-1,Height-1,Width-11,Height-4);
     	Rectangle(Width-1,Height-1,Width-4,Height-11);

	{Triangolino superiore}
       	MoveTo(Width-3,Height-12);
      	LineTo(Width-1,Height-12);
      	MoveTo(Width-2,Height-13);
      	LineTo(Width-1,Height-13);

	{Triangolino inferiore}
      	MoveTo(Width-12,Height-3);
      	LineTo(Width-12,Height-1);
      	MoveTo(Width-13,Height-2);
      	LineTo(Width-13,Height-1);


		{Angolo in alto a destra}

	{2 rettangoli in alto a destra}
      	Rectangle(Width-11,2,Width-1,5);
      	Rectangle(Width-1,13,Width-4,2);


		MoveTo(Width-12,2);
		LineTo(Width-12,4);
		MoveTo(Width-13,2);
                LineTo(Width-13,1);

		MoveTo(Width-2,13);
		LineTo(Width-4,13);
		MoveTo(Width-2,14);
		LineTo(Width-1,14);

{Riassegno il colore nero per ridiseganare i bordi esterni verticali}
      	Pen.Color := clBlack;
   end;
end;


procedure TPanelPicture.SetfColoreAngoli(const Value: TColor);
 begin
  fColoreAngoli := Value;
  Paint;
 end;

procedure TPanelPicture.SetAngoliVisibili(const Value: Boolean);
 begin
  fAngoliVisibili := Value;
  Paint;
 end;

procedure TPanelPicture.SetBorder(const Value: TBorderStyle);
begin
if FBorder <> bsNone then FBorder := bsNone; // Non permetto l'ffetto del bordo
end;

procedure TPanelPicture.MouseDown(Button: TMouseButton;
                    Shift: TShiftState; X, Y: Integer);
begin
  inherited MouseDown(Button,Shift,X,Y);
  if (MovimentoTipo <> Bloccato) and (Button = mbLeft) then begin
    SetCapture(Self.Handle);
    if MovimentoTipo = Form then
       if Parent = Screen.ActiveForm then
          ScreenDC := GetDC(0)
       else
            ScreenDC := GetDC(Parent.Parent.Handle)
    else
        ScreenDC := GetDC(Parent.Handle);

    OldX := X;
    OldY := Y;
    OldLeft := X;
    OldTop := Y;
    if MovimentoTipo = Form then
      MoveRect := Rect(Parent.Left, Parent.Top,
                     Parent.Left + Parent.Width, Parent.Top + Parent.Height)
    else
      MoveRect := Rect(Self.Left, Self.Top,
                     Self.Left + Self.Width, Self.Top + Self.Height);
    DrawFocusRect(ScreenDC,MoveRect);
    Moving := True;
  end;
end;

procedure TPanelPicture.MouseMove(Shift: TShiftState; X,Y: Integer);
begin
  inherited MouseMove(Shift,X,Y);
  if (MovimentoTipo <> Bloccato) and Moving then
   begin  // Inizio se ho auto oppure form
    DrawFocusRect(ScreenDC,MoveRect);
    OldX := X;
    OldY := Y;
    if MovimentoTipo = Form then
  begin  // Inizio modo form
      MoveRect := Rect(Parent.Left+OldX-OldLeft,Parent.Top+OldY-OldTop,
                     Parent.Left+Parent.Width+OldX-OldLeft,Parent.Top+Parent.Height+OldY-OldTop);

 if not fMuoveonLine then exit;
 if (Parent.Left <> Parent.Left+X+OldLeft) or(Parent.Top <> Parent.Top+Y-OldTop) then
  begin  // inizio rigenera form
   Parent.Left := Parent.Left+X-OldLeft;
   Parent.Top := Parent.Top+Y-OldTop;
  end ;  // Fine rigenera form
 end else  // Fine modo form
  begin    //inizio modo auto
   MoveRect := Rect(Self.Left+OldX-OldLeft,Self.Top+OldY-OldTop,
           Self.Left+Self.Width+OldX-OldLeft,Self.Top+Self.Height+OldY-OldTop);
  DrawFocusRect(ScreenDC,MoveRect);
 if not fMuoveonLine then exit;
 if (Self.Left <> Self.Left+X+OldLeft) or (Self.Top <> Self.Top+Y-OldTop) then
   begin // Inizio rigenera componente
    Self.Left := Self.Left+X-OldLeft;
    Self.Top := Self.Top+Y-OldTop;
    end; // Fine rigenera componente
   end ; // Fine modo auto
  end;  // Fine se ho auto oppre form
end;

procedure TPanelPicture.MouseUp(Button: TMouseButton;
              Shift: TShiftState; X, Y: Integer);
begin
 inherited MouseUp(Button,Shift,X,Y);
  if (MovimentoTipo <> Bloccato) and (Button = mbLeft) then
   begin   // Inizio se ho auto oppure form
    ReleaseCapture;
    DrawFocusRect(ScreenDC,MoveRect);
 if (MovimentoTipo = Form) and (not fMuoveonLine) then
  begin // Inizio form
 if (Parent.Left <> Parent.Left+X+OldLeft)or(Parent.Top <> Parent.Top+Y-OldTop) then
  begin  // Inizio rigenerazione form
   Parent.Visible := False;
   Parent.Left := Parent.Left+X-OldLeft;
   Parent.Top := Parent.Top+Y-OldTop;
   Parent.Visible := True;
  end ;  // Fine rigenerazionr form
 end else // Fine form
  begin
   if not fMuoveonLine then
   if (Self.Left <> Self.Left+X+OldLeft) or(Self.Top <> Self.Top+Y-OldTop) then
    begin  // Inizio rigenerazione componente
     Self.Visible := False;
     Self.Left := Self.Left+X-OldLeft;
     Self.Top := Self.Top+Y-OldTop;
     Self.Visible := True;
    end ;  // Fine rigenerazione componente
   end;
    ReleaseDC(0,ScreenDC);
    Moving := False;
  end; // Fine se ho auto oppre form
end;

procedure Register;
 begin
	RegisterComponents('DelphiRuby', [TPanelPicture]);
 end;


end.
